package car;

/**
 * Problem 1.a (5 pts):   From the given sequence interactions with a Car object, 
 * it is clear that the Car object changes its behavior dynamically.  
 * This dynamic change of behavior can be implemented using the state design pattern.  
 * How many states does Car have?  What are they?
 * WRITE YOUR ANSWER HERE:
 * 
 * The car has 3 states: offState, runningState and wreckedState.
 * 
 * 
 * 
 * Problem 1.b:   Of the five Car methods, startEngine, stopEngine, pushAccelerator, 
 * hitTree, getMileage, which ones are state dependent?  Is the field mileage state-dependent?  
 * Add the corresponding state-dependent methods to the abstract class ACarState that 
 * represents the union of all the states of the Car.  
 * WRITE YOU ANSWER HERE AND COMPLETE THE CODE FOR AFOREMENTIONED FIVE Car METHODS BELOW.
 * 
 * Only getMileage is not state-dependent.  The mileage field's value does change depending on 
 * what state the car is in. When the pushAccelerator method is called in the runningState, 
 * the mileage increases by 10.
 * 
 * Problem 1.c:   Using anonymous inner classes to implement all the concrete states 
 * of Car such that the above behavior is replicated.   Your code should conform to the 
 * following restrictions:
 *   -No if-statements should be used anywhere. 
 *   -No additional methods should be added to the Car class.   
 *    Additional fields are acceptable. 
 *   -No additional classes or interfaces may be added that are visible from outside of the 
 *    Car class 
 *   -No parameters need to be passed ever. 
 * WRITE YOUR SOLUTIONS BELOW IN THE Car CLASS DEFINITION.
 * 
 */

/**
 * Modeling a car with state-dependent behaviors.
 */

public class Car {
  
  private int mileage = 0;
  
  private static abstract class ACarState {
    // STUDENT TO DETERMINE WHAT THE STATE-DEPENDENT METHODS ARE AND
    // ADD THE CORRESPONDING ABSTRACT METHODS TO THIS ABSTRACT ACarState.
    // See problem 1.b
    
    abstract String startEngine();
    
    abstract String stopEngine();
    
    abstract String pushAccelerator();
    
    abstract String hitTree();
  } 
  
  // STUDENT TO FIGURE OUT WHAT THE CONCRETE STATES ARE AND
  // CREATE THE CONCRETE STATES AS ANONYMOUS INNER CLASSES.
  // See problem 1.c; code for concrete car states goes here...
  
  private ACarState offState = new ACarState(){
    String startEngine() {
      aCarState = runningState;
      return "Roar!";
    }
    
    String stopEngine() {
      return "[No sound]";
    }
    
    String pushAccelerator() {
      return "[Nothing happens]";
    }
    
    String hitTree() {
      return "[Nothing happens]";
    }
  };
  
  private ACarState runningState = new ACarState(){
    String startEngine() {
      return "Grind!!";
    }
    
    String stopEngine() {
      aCarState = offState;
      return "Rrrrr....sssss....[no more noise]";
    }
    
    String pushAccelerator() {
      mileage += 10;
      return "Zoom, zoom!!";
    }
    
    String hitTree() {
      aCarState = wreckedState;
      return "Crash! Bang!";
    }
  };
  
  private ACarState wreckedState = new ACarState(){
    String startEngine() {
      return "Sputter, sputter";
    }
    
    String stopEngine() {
      return "[Nothing happens]";
    }
    
    String pushAccelerator() {
      return "[Nothing happens]";
    }
    
    String hitTree() {
      return "[Nothing happens]";
    }
  };
  
  // THIS IS THE STATE OF A CAR;
  // STUDENT TO SET aCarState TO AN APPROPRIATE INITIAL STATE
  private ACarState aCarState = offState;
  
  // STUDENT TO APPLY THE STATE PATTERN TO DELEGATE
  // THE STATE-DEPENDENT BEHAVIORS OF A CAR TO ITS STATE.
  // See problem 1.b
  
  public String startEngine() {
    // STUDENT TO COMPLETE
    return aCarState.startEngine();
  }
  
  public String stopEngine() {
    // STUDENT TO COMPLETE
    return aCarState.stopEngine();
  }
  
  public String pushAccelerator() {
    // STUDENT TO COMPLETE
    return aCarState.pushAccelerator();
  }
  
  public String hitTree() {
    // STUDENT TO COMPLETE
    return aCarState.hitTree();
  }
  
  public int getMileage() {
    // STUDENT TO COMPLETE
    return mileage;
  }
}

