package lrs.visitor;
import lrs.*;

/**
 * Check to see if the host is a palindrome.
 */
public class LRSPalin implements IAlgo {
  // STUDENT TO COMPLETE SINGLETON PATTERN CODE IF APPLICABLE.
  public static final LRSPalin Singleton = new LRSPalin();
  private LRSPalin() {}
  
  public Object emptyCase(LRStruct host, Object... nu) {
    // STUDENT TO COMPLETE
    return true;
  }
  
  public Object nonEmptyCase(final LRStruct host, Object... nu) {
    // STUDENT TO COMPLETE
    return host.getRest().execute(new IAlgo() {
      public Object emptyCase(LRStruct h, Object... nu) {
        return true;
      }
      public Object nonEmptyCase(LRStruct h, Object... nu) {
        // Can also remove last from host, but this takes an extra step
        // since we know already that host if followed by a non-empty list, h.
        if(host.getFirst().equals(h.execute(RemLast.Singleton))) {
          // Could also have recursed on host.getRest() instead of h 
          return h.execute(LRSPalin.this);
        }
        else {
          return false;
        }
      }
      
    });
  }
}