package lrs.visitor;
import lrs.*;

/**
 * Return a new LRStruct that is the reverse of the host.
 * The host does not mutate.
 */
public class LRSReverse implements IAlgo {
  // STUDENT TO COMPLETE SINGLETON PATTERN CODE IF APPLICABLE.
  public static final LRSReverse Singleton = new LRSReverse();
  private LRSReverse() {}
  
  
  public Object emptyCase(LRStruct host, Object... nu) {
    return new LRStruct();
  }
  
  public Object nonEmptyCase(LRStruct host, Object... nu) {
    return host.getRest().execute(new IAlgo(){
      public Object emptyCase(LRStruct h, Object... acc) {
        return acc[0];
      }
      public Object nonEmptyCase(LRStruct h, Object... acc) {
        return h.getRest().execute(this, ((LRStruct)acc[0]).insertFront(h.getFirst()));
      }
      
    }, (new LRStruct()).insertFront(host.getFirst()));
  }
}
