package lrs.visitor;
import lrs.*;

/**
 * Removes the last element of an LRStruct.
 */
public class RemLast implements IAlgo {
    // Singleton pattern code goes here...
  public static final RemLast Singleton = new RemLast();
  private RemLast() {}
    
    public Object emptyCase(LRStruct host, Object... inp) {
        throw new java.util.NoSuchElementException("Empty list has no data.");
    }
    
    public Object nonEmptyCase(LRStruct host, Object... inp) {
        return host.getRest().execute(new IAlgo() { 
            
            public Object emptyCase(LRStruct h, Object... p) {
                return ((LRStruct)p[0]).removeFront();
            }
            
            public Object nonEmptyCase(LRStruct h, Object... p) {
                return h.getRest().execute(this, h);
            }
        }, host);
    }
    
}

