package lrs.visitor;
import lrs.*;
import java.util.*;

import junit.framework.TestCase;

/**
 * A JUnit test case class.
 * Every method starting with the word "test" will be called when running
 * the test with JUnit.
 */
public class RandomSwap_Test extends TestCase {
  
  public void test_RandomSwap() {
    LRStruct lrs = new LRStruct();
    // initialize random number generator with known, specific generator
    IAlgo algo = new RandomSwap(new Random(0)); 
    assertEquals("Empty list", "()", lrs.execute(algo).toString());
    lrs.insertFront("a");
    assertEquals("(a)", "(a)", lrs.execute(algo).toString());
    lrs.insertFront("b");
    assertEquals("(b a)", "(b a)", lrs.execute(algo).toString());
    lrs.insertFront("c");
    assertEquals("(c b a)", "(b c a)", lrs.execute(algo).toString());
    lrs.insertFront("d");
    assertEquals("(d b c a)", "(b d c a)", lrs.execute(algo).toString());
    lrs.insertFront("e");
    assertEquals("(e b d c a)", "(a b d c e)", lrs.execute(algo).toString());
    lrs.insertFront("f");
    assertEquals("(f a b d c e)", "(f a b d c e)", lrs.execute(algo).toString());
    lrs.insertFront("g");
    assertEquals("(g f a b d c e)", "(d f a b g c e)", lrs.execute(algo).toString());  
  }
  
  
  public void test_Randomize() {
    LRStruct lrs = new LRStruct();
    // initialize random number generator with known, specific generator
    IAlgo algo = new Randomize(new Random(0));
    assertEquals("Empty list", "()", lrs.execute(algo).toString());
    lrs.insertFront("a");
    assertEquals("(a)", "(a)", lrs.execute(algo).toString());
    lrs.insertFront("b");
    assertEquals("(b a)", "(a b)", lrs.execute(algo).toString());
    lrs.insertFront("c");
    assertEquals("(c a b)", "(c a b)", lrs.execute(algo).toString());
    lrs.insertFront("d");
    assertEquals("(d c a b)", "(d a b c)", lrs.execute(algo).toString());
    lrs.insertFront("e");
    assertEquals("(e d a b c)", "(b a d c e)", lrs.execute(algo).toString());
    lrs.insertFront("f");
    assertEquals("(f b a d c e)", "(c d a e f b)", lrs.execute(algo).toString());
    lrs.insertFront("g");
    assertEquals("(g c d a e f b)", "(f g a c e b d)", lrs.execute(algo).toString());
  }
}
