package lrs.visitor;
import lrs.*;
import java.util.*;

/**
 * Randomizes the order of the elements in an LRStruct
 * Mutates the host list.  Returns the host list.
 */
public class Randomize implements IAlgo {
  
  /**
   * The RandomSwap algorithm used by the randomization process.
   */
  IAlgo randomSwap;
  
  public Randomize() {
    this(new Random()); // delegates to the other constructor
  }
  
  public Randomize(Random rand) {
    randomSwap = new RandomSwap(rand);
  }  
  /**
   * Does nothing
   * @param host an empty LRStruct.
   * @param nu not used
   * @return LRStruct host
   */
  public Object emptyCase(LRStruct host, Object... nu) {
    // STUDENT TO COMPLETE
    return host;
  }
  
  /**
   * Randomly swaps the first element with a random element in the rest of the list.
   * @param host a non-empty LRStruct.
   * @param nu not used
   * @return LRStruct host
   */
  public Object nonEmptyCase(LRStruct host, Object... nu) {
    // STUDENT TO COMPLETE
    host.getRest().execute(this);
    return host.execute(randomSwap);
  }
}